function  coord_calc(i,i1,i2,i4,i5)
%CALCULATE NODAL POINT COORDINATES

global rn
global npn
global xord
global yord
global xcor
global ycor
global meltyp

switch meltyp
    case 3
        dx=1/i1; dy = 1/i4; % 1/number of divisions on each side
    case 4
        r=i1;
        dx= 1.0/(r);
        r=i4;
        dy= 1.0/(r);
    case 6
        r=2*i1;
        dx= 1.0/(r);
        r=2*i4;
        dy= 1.0/(r);
    case 9
        r=2*i1;
        dx= 1.0/(r);
        r=2*i4;
        dy= 1.0/(r);
end



jbgn=1;
jend=i5;

kbgn = 1;
kend = i2;

k1=0;

for j=jbgn:1:jend

    r=j-1;
    ry = r*dy;

    for  k=kbgn:1:kend

        r=k-1;
        rx = r*dx;

        rn(1)= +1.0*(1.0-rx)*(1.0-ry)*(1.0-2.0*rx-2.0*ry);
        rn(2)= +4.0*(rx)*(1.0-rx)*(1.0-ry);
        rn(3)= -1.0*(rx)*(1.0-ry)*(1.0-2.0*rx+2.0*ry);
        rn(4)= +4.0*(rx)*(ry)*(1.0-ry);
        rn(5)= -1.0*(rx)*(ry)*(3.0-2.0*rx-2.0*ry);
        rn(6)= +4.0*(rx)*(1.0-rx)*(ry);
        rn(7)= -1.0*(1.0-rx)*(ry)*(1.0+2.0*rx-2.0*ry);
        rn(8)= +4.0*(1.0-rx)*(ry)*(1.0-ry);

        k1=k1+1;
        k2=npn(k1);

        xord(k2)=0.0;
        yord(k2)=0.0;

        for l=1:1:8

            xord(k2)=xord(k2)+rn(l)*xcor(i,l);
            yord(k2)=yord(k2)+rn(l)*ycor(i,l);

        end
    end


end
